use master
go
--IF EXISTS (SELECT * FROM sys.objects WHERE name = 'DemoClassification')
	--DROP FUNCTION dbo.DemoClassification
--GO
IF EXISTS (SELECT * FROM sys.resource_governor_workload_groups WHERE name = 'WG_Admin')
	DROP WORKLOAD GROUP WG_Admin
GO
IF EXISTS (SELECT * FROM sys.resource_governor_workload_groups WHERE name = 'WG_Adhock')
	DROP WORKLOAD GROUP WG_Adhock
GO
IF EXISTS (SELECT * FROM sys.resource_governor_workload_groups WHERE name = 'WG_Normal')
	DROP WORKLOAD GROUP WG_Normal
GO
IF EXISTS (SELECT * FROM sys.resource_governor_workload_groups  WHERE name = 'WG_Low')
	DROP WORKLOAD GROUP WG_Low
GO
IF EXISTS (SELECT * FROM sys.resource_governor_resource_pools WHERE name = 'RP_Low')
	DROP RESOURCE POOL RP_Low
GO
IF EXISTS (SELECT * FROM sys.resource_governor_resource_pools WHERE name = 'RP_Medium')
	DROP RESOURCE POOL RP_Medium
GO
IF EXISTS (SELECT * FROM sys.resource_governor_resource_pools WHERE name = 'RP_Normal')
	DROP RESOURCE POOL RP_Normal
GO
CREATE FUNCTION dbo.DemoClassification ()
	RETURNS sysname
WITH SCHEMABINDING
AS
BEGIN
	/*Declare backwords, starting with the
	  most restrictive groups, to the highest
	  level group.*/
	DECLARE @Group as sysname
	IF UPPER(APP_NAME()) LIKE '%MANAGEMENT STUDIO%'
		SET @Group = 'WG_Adhock'
	IF UPPER(APP_NAME()) LIKE '%Project1%'
		SET @Group = 'WG_Adhock'
	IF UPPER(APP_NAME()) LIKE '%ProductionApp%'
		SET @Group = 'WG_Normal'
	IF SUSER_SNAME() = 'CrystalReportsUser'
		SET @Group = 'WG_Low'	
	IF SUSER_SNAME() = 'sa'
		SET @Group = 'WG_Admin'
		
		RETURN @Group
END
GO
CREATE RESOURCE POOL RP_Low
WITH
(
	MAX_CPU_PERCENT=25,
	MAX_MEMORY_PERCENT=10
)
GO
CREATE RESOURCE POOL RP_Medium
WITH
(
	MAX_CPU_PERCENT=25,
	MAX_MEMORY_PERCENT=25
)
GO
CREATE RESOURCE POOL RP_Normal
WITH
(
	MIN_CPU_PERCENT=25,
	MAX_CPU_PERCENT=75,
	MIN_MEMORY_PERCENT=25
)
GO
CREATE WORKLOAD GROUP WG_Admin
WITH
(
	IMPORTANCE = High
)
USING RP_Medium
GO
CREATE WORKLOAD GROUP WG_Adhock
WITH
(
	IMPORTANCE = Low,
	MAX_DOP=1,
	GROUP_MAX_REQUESTS=2
)
USING RP_Low
GO
CREATE WORKLOAD GROUP WG_Normal
WITH 
(
	IMPORTANCE = High
)
USING RP_Normal
GO
CREATE WORKLOAD GROUP WG_Low
WITH
(
	IMPORTANCE = Low
)
USING RP_Low
GO
ALTER RESOURCE GOVERNOR WITH (CLASSIFIER_FUNCTION = dbo.DemoClassification)
ALTER RESOURCE GOVERNOR RECONFIGURE
GO